package jp.sourceforge.sgerrard.action;

import java.io.IOException;
import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.List;

import javax.annotation.Resource;

import jp.sourceforge.sgerrard.entity.Emp;
import jp.sourceforge.sgerrard.form.EmpForm;
import jp.sourceforge.sgerrard.service.EmpService;

import org.apache.commons.lang.StringUtils;
import org.seasar.struts.annotation.ActionForm;
import org.seasar.struts.annotation.Execute;

public class EmpAction {

  @Resource
  private EmpService empService;

  @ActionForm
  @Resource
  private EmpForm empForm;

  public List<Emp> emps;

  @Execute(validator = false)
  public String index() {
    this.empForm.emp = this.empService.findById(Integer.parseInt(this.empForm.empNo));

    return "emp.jsp";
  }

  @Execute(validator = false)
  public String list() {
    this.emps = this.empService.findAll();

    return "list.jsp";
  }

  @Execute(validator = false)
  public String edit() throws IOException {
    this.empForm.emp = this.empService.findById(Integer.parseInt(this.empForm.empNo));

    return "edit.jsp";
  }

  @Execute(validator = false)
  public String save() throws IOException {
    Emp emp = new Emp();

    emp.empNo = Short.parseShort(this.empForm.empNo);
    emp.empName = this.empForm.empName;
    emp.job = this.empForm.job;
    if (StringUtils.isNotBlank(this.empForm.mgrId)) {
      emp.mgrId = Short.parseShort(this.empForm.mgrId);
    }

    if (StringUtils.isNotBlank(this.empForm.hiredate)) {
      SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
      try {
        emp.hiredate = sdf.parse(this.empForm.hiredate);
      } catch (ParseException e) {
        e.printStackTrace();
      }
    }

    if (StringUtils.isNotBlank(this.empForm.sal)) {
      emp.sal = new BigDecimal(this.empForm.sal);
    }
    if (StringUtils.isNotBlank(this.empForm.comm)) {
      emp.comm = new BigDecimal(this.empForm.comm);
    }

    this.empService.update(emp);
    this.empForm.emp = emp;

    return "emp.jsp";
  }

}
